import javax.swing.*;
import java.io.File;

import model.TriangleModel;
import view.ScriptingView;
import view.*;

import org.python.core.PyObject;
import org.python.util.PythonInterpreter;

public class Main_5_Scripting {

	public static void main(String[] args) {
		model.TriangleModel model = TriangleModel.getInstance();

		PythonInterpreter pyInterp = new PythonInterpreter();
		pyInterp.set("model", model);
		
		if (args.length == 1) {
			// Running a script
			pyInterp.execfile(args[0]);
		} else {
			// Running interactively
			// Run initialization script
			GraphicalView vGraphical = new GraphicalView(model);
			TextView vText = new TextView(model);
			ScriptingView vScript = new ScriptingView(model);
			JMenuBar menus = MenuView.getInstance(model);

			
			JFrame frame = new JFrame("Triangle");
			Box top = Box.createHorizontalBox();
			top.add(vText);
			top.add(vGraphical);
			JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, top, vScript);
			split.setDividerLocation(0.5);
			frame.getContentPane().add(split);
			frame.setJMenuBar(menus);
			
			frame.setBounds(50, 50, 500, 500);
			
			if (new File("tri.ini").canRead()) {
				pyInterp.set("frame", frame);
				pyInterp.execfile("tri.ini");				
			}

			frame.setVisible(true);			
		}
	}
	
}
