package view;

import javax.swing.*;

import java.awt.Color;
import java.awt.event.*;
import javax.swing.undo.*;

import org.python.core.PyObject;
import org.python.util.PythonInterpreter;

import model.*;

public class ScriptingView extends JPanel {
	private TriangleModel model;
	private JTextArea script;
	private JButton execute;
	private static PythonInterpreter pyInterp = new PythonInterpreter();
	
	public ScriptingView(TriangleModel model) {
		this.model = model;
		this.layoutView();
		this.registerListeners();
	}
	
	private void layoutView() {
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		this.script = new JTextArea();
		this.script.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.GRAY), "Script"));
		this.execute = new JButton("Execute");
		this.add(this.script);
		this.add(this.execute);
	}
	
	private void registerListeners() {
		this.execute.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// Set-up for undo
				final double oldBase = model.getBase();
				final double oldHeight = model.getHeight();
				
				pyInterp.set("model", ScriptingView.this.model);
				final String s = ScriptingView.this.script.getText();
				
				new Thread(new Runnable() {
					public void run() {
						pyInterp.exec(s);		
						
						UndoableEdit cmd = model.getSetValuesCommand(oldBase, model.getBase(), oldHeight, model.getHeight());
						MenuView.getUndoManager().addEdit(cmd);
					}
				}).start();
			}
		});
	}
}
